From 40cc4a782a963547e4ff55996c96a1bdf935b1f6 Mon Sep 17 00:00:00 2001
From: Valmiky Arquissandas <valmiky.arquissandas@ist.utl.pt>
Date: Wed, 25 Jul 2012 20:33:17 +0100
Subject: [PATCH] Added "scope" as a configurable option.

---
 etc/RT_SiteConfig.pm               |    2 ++
 lib/RT/Authen/ExternalAuth/LDAP.pm |    3 ++-
 2 files changed, 4 insertions(+), 1 deletions(-)

diff --git a/etc/RT_SiteConfig.pm b/etc/RT_SiteConfig.pm
index a080d40..5f86a69 100644
--- a/etc/RT_SiteConfig.pm
+++ b/etc/RT_SiteConfig.pm
@@ -108,6 +108,8 @@ Set($ExternalSettings,      {   # AN EXAMPLE DB SERVICE
                                                         #
                                                         # The LDAP search base
                                                         'base'                      =>  'ou=Organisational Unit,dc=domain,dc=TLD',
+                                                        # The LDAP search scope (base, one, sub)
+                                                        'scope'                     =>  'base',
                                                         #
                                                         # ALL FILTERS MUST BE VALID LDAP FILTERS ENCASED IN PARENTHESES!
                                                         # YOU **MUST** SPECIFY A filter AND A d_filter!!
diff --git a/lib/RT/Authen/ExternalAuth/LDAP.pm b/lib/RT/Authen/ExternalAuth/LDAP.pm
index b228e77..7e95dc9 100644
--- a/lib/RT/Authen/ExternalAuth/LDAP.pm
+++ b/lib/RT/Authen/ExternalAuth/LDAP.pm
@@ -21,6 +21,7 @@ sub GetAuth {
     my $group_attr      = $config->{'group_attr'};
     my $group_attr_val  = $config->{'group_attr_value'} || 'dn';
     my $attr_map        = $config->{'attr_map'};
+    my $scope           = $config->{'scope'};
     my @attrs           = ('dn');
 
     # Make sure we fetch the user attribute we'll need for the group check
@@ -126,7 +127,7 @@ sub GetAuth {
         $ldap_msg = $ldap->search(  base   => $group,
                                     filter => $filter,
                                     attrs  => \@attrs,
-                                    scope  => 'base');
+                                    scope  => $scope);
 
         # And the user isn't a member:
         unless ($ldap_msg->code == LDAP_SUCCESS || 
-- 
1.7.2.5

